/////////////////////////////////////////////////////////////////////////////
// GetAngleDlg.cpp : implementationfile
//
// the action takes place here, in NGprotocol.cpp and in CCom
// most important are OnTimer, OnStart and OnStop (last three functions)
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#include "Com.h"
#include "NGprotocol.h"

#include "GetAngle.h"
#include "GetAngleDlg.h"

#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern SCom g_ComValues; // initialization values for the serial port

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialog for the "About..." command

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-support
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SetDlgItemText(IDC_ABOUTTEXT,"The source code for this application is meant as an example "
		           "for programming a Windows 95/98 application for the SEIKA NG360 inclinometer."
				   "\r\n\r\n"
				   "Feel free to use the source in any way you see fit - but only give away "
				   "this example in its complete, unmodified form."
				   "\r\n\r\n"
				   "The NG360 VC++ Example is not meant to be actually used in any form! "
				   "Its error handling gives the user feedback on every occasion making the "
				   "program fault intolerant and not suitable for anything but a programming "
				   "example."
				   "\r\n\r\n"
				   "The project was developed using MSVC Version 5.0 and MFC.");
	
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CGetAngleDlg Dialog - the main dialog for this application

CGetAngleDlg::CGetAngleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetAngleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGetAngleDlg)
		// HINT: the Class Assistant inserts member-initialization here
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGetAngleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGetAngleDlg)
		// HINT: the Class Assistant inserts DDX- and DDV-calls  here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGetAngleDlg, CDialog)
	//{{AFX_MSG_MAP(CGetAngleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetAngleDlg Message-Handler

/////////////////////////////////////////////////////////////////////////////
// OnInitDialog: initialize the example application

BOOL CGetAngleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Insert command "About..." to the system menu.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon,TRUE); // use small symbol
	
	// initialize member variables
	ComPort=1;   // set the standard serial port to Com1
	Address=177; // set the standard address to 177 (hB1) - the user must change this if he uses more than
	             // one sensor on the bus
	
	TimerId=0; 
	TimerStatus=0;

	// initialize dialog controls
	SendDlgItemMessage(IDC_COMPORT,CB_SETCURSEL,ComPort-1,0);
	SendDlgItemMessage(IDC_ADDRESS,CB_SETCURSEL,Address-177,0);
	SetDlgItemText(IDC_ANGLE,"");    
	
	GetDlgItem(IDC_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOP)->EnableWindow(FALSE);

	if(g_ComValues.USBConverter) ((CButton*)GetDlgItem(IDC_USBCONTROLLER))->SetCheck(1);
	else                         ((CButton*)GetDlgItem(IDC_USBCONTROLLER))->SetCheck(0);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// OnSysCommand: process the "About..." command

void CGetAngleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

/////////////////////////////////////////////////////////////////////////////
// OnTimer: read the current inclinometer angle and show it to the user

void CGetAngleDlg::OnTimer(UINT nIDEvent) 
{
	if(TimerStatus==2)              // handle overlapping calls
	{                               // to the OnTimer function
		CDialog::OnTimer(nIDEvent); //
		return;                     //
	}                               //
	TimerStatus=2;                  //

	
	Angle=NG_GetAngle(Address);     // -> read data from the inclinometer

	if(Angle==-1) 
	{
		Angle=NG_GetAngle(Address); // -> retry, if the transmission failed
		if(Angle==-1) OnStop();     // -> stop measuring in case of another error
	}

	char c[32];
	sprintf(c,"%06.2f",Angle);
	SetDlgItemText(IDC_ANGLE,c);    // and show it in the Dialog
	
	CDialog::OnTimer(nIDEvent);
	TimerStatus=1;                  // a new valid call to OnTimer will be possible
}

/////////////////////////////////////////////////////////////////////////////
// OnStart: open communications to the sensor and set the timer

void CGetAngleDlg::OnStart() 
{
	char ct=0;
	
	ComPort=SendDlgItemMessage(IDC_COMPORT,CB_GETCURSEL,0,0)+1; // in any other software, comboboxes values
	Address=GetDlgItemInt(IDC_ADDRESS,NULL,TRUE);               // should be checked for plausibility

	g_ComValues.USBConverter=((CButton*)GetDlgItem(IDC_USBCONTROLLER))->GetCheck();

	if(NG_OpenPort(ComPort))        // -> initialize serial port to sensor
	{
		if(TimerId==0)
			TimerId=SetTimer(ID_GADTIMER,10,NULL); // call OnTimer every 10ms
		if(TimerId==0)
		{
			MessageBox("Timer could not be installed.","GetAngle ERROR",MB_OK | MB_ICONSTOP);
		} else {
			TimerStatus=1;
			GetDlgItem(IDC_COMPORT)->EnableWindow(FALSE); // reading enabled - 
			GetDlgItem(IDC_ADDRESS)->EnableWindow(FALSE); // activate/deactivate the appropriate controls
			GetDlgItem(IDC_START)->EnableWindow(FALSE);
			GetDlgItem(IDC_STOP)->EnableWindow(TRUE);
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// OnStop: remove the timer and close communications port

void CGetAngleDlg::OnStop() 
{
	if(TimerId!=0) 
	{
		KillTimer(TimerId); // do not make any further calls to OnTimer
		TimerId=0;
	}
	NG_ClosePort();                 // -> close the port to allow future access

	GetDlgItem(IDC_COMPORT)->EnableWindow(TRUE); // reading disabled - 
	GetDlgItem(IDC_ADDRESS)->EnableWindow(TRUE); // activate/deactivate the appropriate controls
	GetDlgItem(IDC_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_STOP)->EnableWindow(FALSE);
}

